;*******************************************************************************
; Filename:      hfcheck.asm
; Date:          2018.06.23.
; File Version:  V1.0
; Author:        PGY
; Company:       BME-IIT
; Description:
;   Microchip CURIOSITY HPC panel 
;   Fosc = 32MHz, bels? oszcilltor, utasts ciklusideje: Tcy=125ns
;   Demo feladat szimultor kiprblshoz
; ?rjon programot, amely a PORTB 4. bitjre kapcsolt alacsony aktv nyomgomb 
; lenyomsnak hatsra (lefut l) kt darab 10us hosszsg impulzust llt el? 
; 20us tvolsggal a mikrokontroller RA7 kimenetn.?
;*******************************************************************************
; PIC16F18875 Configuration Bit Settings
#include "p16f18875.inc"
 __CONFIG _CONFIG1, 0x3F8C
 __CONFIG _CONFIG2, 0x3F3F
 __CONFIG _CONFIG3, 0x3F9F
 __CONFIG _CONFIG4, 0x3FFF
 __CONFIG _CONFIG5, 0x3FFF 
;*******************************************************************************
; Reset Vector
;*******************************************************************************
RES_VECT  CODE    0x0000            ; processor reset vector
    GOTO    START                   ; go to beginning of program
; MAIN PROGRAM
;*******************************************************************************
#define	Gomb_S1	PORTB,4
#define	Gomb_S1_IRANY	TRISB,4
#define	Gomb_S2	PORTC,5
#define	Gomb_S2_IRANY	TRISC,5
#define	LED_D2	LATA,4
#define	LED_D2_IRANY	TRISA,4
#define	LED_D3	LATA,5
#define	LED_D3_IRANY	TRISA,5
#define	LED_D4	LATA,6
#define	LED_D4_IRANY	TRISA,6
#define	LED_D5	LATA,7
#define	LED_D5_IRANY	TRISA,7

GPR_VAR	UDATA 0x20  ; BANK0, vltoz terlet kezdete
BITCNT	RES	1   ; ciklusvltoz

MAIN_PROG CODE         ; Kdszegmens eleje

START:
	BANKSEL ANSELA
	CLRF	ANSELA	; port digitlis
	CLRF	ANSELB	; port digitlis
	CLRF	ANSELC	; port digitlis
	BANKSEL LATA
	NOV LED_D2	; ez egy szintaktikai hiba
	BCF	LED_D2		; kezdortk
	BCF	LED_D2_IRANY	; kimenet
	BCF	LED_D3		; kezdortk
	BCF	LED_D3_IRANY	; kimenet
	BCF	LED_D4		; kezdortk
	BCF	LED_D4_IRANY	; kimenet
	BCF	LED_D5		; kezdortk
	BSF	LED_D5_IRANY	; kimenet
	
	BSF	Gomb_S1_IRANY	; bemenet
	CLRF	STATUS
MAIN_LOOP:
	BTFSS	Gomb_S1	; alaphelyzetre vr
	GOTO	MAIN_LOOP
Var0:	
	BTFSC	Gomb_S1	; lefut l 
	GOTO	Var0
	MOVLW	D'02'
	MOVWF	BITCNT
PULS_LOOP:	
	DECF	BITCNT,F	; ciklus vltoz cskkentse
	BTFSC	STATUS,C
	GOTO	MAIN_LOOP
	BSF	LED_D5	; LED bekapcsolsa
	CALL	Delay10us
	BCF	LED_D5	; LED kikapcsolsa
	CALL	Delay10us
	GOTO	PULS_LOOP
	GOTO	MAIN_LOOP
		
Delay10us: ; 125ns/ciklus@Fosc=32MHz-->8MHZ instructionclock
	MOVLW	D'10'	; 3
D10CK:
	DECFSZ	WREG,W	; 1 /2
	GOTO	D10CK	; 2
	RETURN		; 2

    END
